import { MrParkitGarageTransformation } from "#ie/transformations/MrParkitGarageTransformation";
import { expect } from "chai";
import { MrParkitInputDataFixture } from "../data/MrParkitInputDataFixture";

describe("MrParkitGarageTransformation", () => {
    it("should transform input data", async () => {
        const transformationDate = new Date("2023-11-20T08:21:32.081Z");
        const transformation = new MrParkitGarageTransformation(transformationDate);
        const result = transformation.transformArray(MrParkitInputDataFixture);
        expect(result).to.be.an("array").that.has.lengthOf(2);
        expect(result[0]).to.deep.equal({
            id: "mr_parkit-463253c6-852d-41d4-8082-96532a97eeac",
            source: "mr_parkit",
            source_id: "463253c6-852d-41d4-8082-96532a97eeac",
            data_provider: "www.mrparkit.com",
            name: "Anděl Park - Radlická 14",
            location: {
                type: "Point",
                coordinates: [14.4009956, 50.0705288],
            },
            centroid: {
                type: "Point",
                coordinates: [14.4009956, 50.0705288],
            },
            total_spot_number: null,
            tariff_id: "463253c6-852d-41d4-8082-96532a97eeac",
            date_modified: transformationDate.toISOString(),
            valid_from: undefined,
            parking_type: "underground",
            active: true,
            address: {
                address_country: "Česko",
                address_formatted: "Radlická 14, Praha 5",
            },
            security: false,
            max_vehicle_dimensions: [5.3, 2.3, 1.9, 0],
            parkingLocation: {
                id: "mr_parkit-463253c6-852d-41d4-8082-96532a97eeac",
                source: "mr_parkit",
                source_id: "463253c6-852d-41d4-8082-96532a97eeac",
                data_provider: "www.mrparkit.com",
                location: {
                    type: "Point",
                    coordinates: [14.4009956, 50.0705288],
                },
                centroid: {
                    type: "Point",
                    coordinates: [14.4009956, 50.0705288],
                },
                total_spot_number: null,
                address: {
                    address_country: "Česko",
                    address_formatted: "Radlická 14, Praha 5",
                },
                special_access: null,
            },
            parkingMeasurement: {
                parking_id: "mr_parkit-463253c6-852d-41d4-8082-96532a97eeac",
                source: "mr_parkit",
                source_id: "463253c6-852d-41d4-8082-96532a97eeac",
                available_spot_number: 1,
                date_modified: transformationDate.toISOString(),
                occupied_spot_number: null,
                total_spot_number: null,
            },
            parkingProhibitions: {
                lpg: false,
                motorcycle: true,
                parking_id: "mr_parkit-463253c6-852d-41d4-8082-96532a97eeac",
                source: "mr_parkit",
            },
            tariffs: [
                {
                    charge_band_name: "Anděl Park - Radlická 14",
                    source: "mr_parkit",
                    tariff_id: "463253c6-852d-41d4-8082-96532a97eeac",
                    last_updated: transformationDate.toISOString(),
                    free_of_charge: false,
                    payment_mode: "pre_paid",
                    charge_currency: "czk",
                    valid_from: transformationDate.toISOString(),
                    charge: 16.6,
                    charge_type: "other",
                    charge_order_index: 0,
                    charge_interval: 3600,
                    max_iterations_of_charge: 24,
                    min_iterations_of_charge: 12,
                    periods_of_time: [
                        {
                            day_in_week: "Mo",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Mo",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Tu",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Tu",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "We",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "We",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Th",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Th",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Fr",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Fr",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Sa",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Sa",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Su",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Su",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                    ],
                },
                {
                    charge_band_name: "Anděl Park - Radlická 14",
                    source: "mr_parkit",
                    tariff_id: "463253c6-852d-41d4-8082-96532a97eeac",
                    last_updated: transformationDate.toISOString(),
                    free_of_charge: false,
                    payment_mode: "pre_paid",
                    charge_currency: "czk",
                    valid_from: transformationDate.toISOString(),
                    charge: 349,
                    charge_type: "other",
                    charge_order_index: 1,
                    charge_interval: 86400,
                    max_iterations_of_charge: 30,
                    min_iterations_of_charge: 0,
                    periods_of_time: [
                        {
                            day_in_week: "Mo",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Mo",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Tu",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Tu",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "We",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "We",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Th",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Th",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Fr",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Fr",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Sa",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Sa",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Su",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Su",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                    ],
                },
                {
                    charge_band_name: "Anděl Park - Radlická 14",
                    source: "mr_parkit",
                    tariff_id: "463253c6-852d-41d4-8082-96532a97eeac",
                    last_updated: transformationDate.toISOString(),
                    free_of_charge: false,
                    payment_mode: "pre_paid",
                    charge_currency: "czk",
                    valid_from: transformationDate.toISOString(),
                    charge: 698,
                    charge_type: "other",
                    charge_order_index: 2,
                    charge_interval: 172800,
                    max_iterations_of_charge: 1,
                    min_iterations_of_charge: 0,
                    periods_of_time: [
                        {
                            day_in_week: "Sa",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Sa",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Su",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Su",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                    ],
                },
            ],
        });
        expect(result[1]).to.deep.equal({
            id: "mr_parkit-1e9f986f-79d2-4fc7-94d6-32400e76b1ed",
            source: "mr_parkit",
            source_id: "1e9f986f-79d2-4fc7-94d6-32400e76b1ed",
            data_provider: "www.mrparkit.com",
            name: "Anglická 20",
            location: {
                type: "Point",
                coordinates: [14.4337195, 50.0762453],
            },
            centroid: {
                type: "Point",
                coordinates: [14.4337195, 50.0762453],
            },
            total_spot_number: null,
            tariff_id: "1e9f986f-79d2-4fc7-94d6-32400e76b1ed",
            date_modified: transformationDate.toISOString(),
            valid_from: undefined,
            parking_type: "underground",
            parkingProhibitions: {
                lpg: false,
                motorcycle: true,
                parking_id: "mr_parkit-1e9f986f-79d2-4fc7-94d6-32400e76b1ed",
                source: "mr_parkit",
            },
            active: true,
            address: {
                address_country: "Česko",
                address_formatted: "Anglická 20, Praha 2",
            },
            security: true,
            max_vehicle_dimensions: [5.5, 2.2, 1.9, 0],
            parkingLocation: {
                id: "mr_parkit-1e9f986f-79d2-4fc7-94d6-32400e76b1ed",
                source: "mr_parkit",
                source_id: "1e9f986f-79d2-4fc7-94d6-32400e76b1ed",
                data_provider: "www.mrparkit.com",
                location: {
                    type: "Point",
                    coordinates: [14.4337195, 50.0762453],
                },
                centroid: {
                    type: "Point",
                    coordinates: [14.4337195, 50.0762453],
                },
                total_spot_number: null,
                address: {
                    address_country: "Česko",
                    address_formatted: "Anglická 20, Praha 2",
                },
                special_access: null,
            },
            parkingMeasurement: {
                parking_id: "mr_parkit-1e9f986f-79d2-4fc7-94d6-32400e76b1ed",
                source: "mr_parkit",
                source_id: "1e9f986f-79d2-4fc7-94d6-32400e76b1ed",
                available_spot_number: 0,
                date_modified: transformationDate.toISOString(),
                occupied_spot_number: null,
                total_spot_number: null,
            },
            tariffs: [
                {
                    charge_band_name: "Anglická 20",
                    source: "mr_parkit",
                    tariff_id: "1e9f986f-79d2-4fc7-94d6-32400e76b1ed",
                    last_updated: transformationDate.toISOString(),
                    free_of_charge: false,
                    payment_mode: "pre_paid",
                    charge_currency: "czk",
                    valid_from: transformationDate.toISOString(),
                    charge: 24.9,
                    charge_type: "other",
                    charge_order_index: 0,
                    charge_interval: 3600,
                    max_iterations_of_charge: 24,
                    min_iterations_of_charge: 12,
                    periods_of_time: [
                        {
                            day_in_week: "Mo",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Mo",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Tu",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Tu",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "We",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "We",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Th",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Th",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Fr",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Fr",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Sa",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Sa",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Su",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Su",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                    ],
                },
                {
                    charge_band_name: "Anglická 20",
                    source: "mr_parkit",
                    tariff_id: "1e9f986f-79d2-4fc7-94d6-32400e76b1ed",
                    last_updated: transformationDate.toISOString(),
                    free_of_charge: false,
                    payment_mode: "pre_paid",
                    charge_currency: "czk",
                    valid_from: transformationDate.toISOString(),
                    charge: 549,
                    charge_type: "other",
                    charge_order_index: 1,
                    charge_interval: 86400,
                    max_iterations_of_charge: 30,
                    min_iterations_of_charge: 0,
                    periods_of_time: [
                        {
                            day_in_week: "Mo",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Mo",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Tu",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Tu",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "We",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "We",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Th",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Th",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Fr",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Fr",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Sa",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Sa",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Su",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Su",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                    ],
                },
                {
                    charge_band_name: "Anglická 20",
                    source: "mr_parkit",
                    tariff_id: "1e9f986f-79d2-4fc7-94d6-32400e76b1ed",
                    last_updated: transformationDate.toISOString(),
                    free_of_charge: false,
                    payment_mode: "pre_paid",
                    charge_currency: "czk",
                    valid_from: transformationDate.toISOString(),
                    charge: 1098,
                    charge_type: "other",
                    charge_order_index: 2,
                    charge_interval: 172800,
                    max_iterations_of_charge: 1,
                    min_iterations_of_charge: 0,
                    periods_of_time: [
                        {
                            day_in_week: "Sa",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Sa",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                        {
                            day_in_week: "Su",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_off",
                        },
                        {
                            day_in_week: "Su",
                            start: "00:00",
                            end: "23:59",
                            ph: "ph_only",
                        },
                    ],
                },
            ],
        });
    });
});
